<script setup>
import { ref, computed, shallowRef } from 'vue';
import Game from '../../game';
import { SET_SLOT } from '../../events';
import { useRollOver } from '../../store/popups';
import { gameEvents } from '../../events';
import Choice from '../popups/choice.vue';

/**
 * @property {string} pick - slot to pick item for. (slot is Vue reserved)
 * @property {?string} title - name to display to user. defaults to pick.
 * @property {?Item[]} choices - list of items to filter. if not set, all game items are tested
 * for a matching slot property.
 * @property {?string} pickEvent - event to emit on item picked.
 * @property {?string} nonetext - text to display when nothing selected.
 * @property {?boolean} hideEmpty - hide slot picker when no options available
 * @property {?boolean} mustPay - must pay for item when picking it.
 */
const props = defineProps(
	['pick',
	'nonetext',
	'title',
	'choices',
	'pickEvent',
	'hideEmpty',
	'mustPay',
	'state']);

const state = computed(()=>props.state ?? Game );
const cur = shallowRef(state.value.getSlot(props.pick));
const elRef = shallowRef();
const { itemOver } = useRollOver();

const picking = ref(false);

const doPick = ()=>{
	picking.value=true;
}
const onSelect = (p) => {

	if (p) {

		gameEvents.emit(
			props.pickEvent || SET_SLOT,
			p);
		cur.value = state.value.getSlot(props.pick);
	}
	picking.value=false;
}


const avail = computed(() => {
	return props.choices ? props.choices :
		state.value.filterItems((v) =>
			v.slot === props.pick && !v.disabled && !v.locks && !v.locked
			&& (v.owned || !v.buy));
})


</script>

<template>
<div ref="elRef" v-if="!hideEmpty || avail.length > 0">

	<span v-if="title">{{ title }}:</span>
	<button class="task-btn" @mouseenter.capture.stop="itemOver($event, cur)" @click="doPick" v-if="avail.length > 0">{{ cur ? cur.name : (nonetext ? nonetext : 'None') }}</button>

	<Choice v-if="picking"
		@selected="onSelect"
		@cancel="picking=false"
		:choices="avail"
		:title="title||pick"
		:mustPay="mustPay"
		:elm="elRef"
		:state="state" />
</div>
</template>
